<?php
/*****************************************************************************/
/* Install.php                                                               */
/*****************************************************************************/
/* YaBB: Yet another Bulletin Board                                          */
/* Open-Source Project started by Zef Hemel (zef@zefnet.com)                 */
/* Software Version: YaBB SE                                                 */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/*                             http://www.yabbforum.com/community            */
/* ========================================================================= */
/* Copyright (c) 2001-2002 The YaBB SE Development Team                      */
/* Software by: The YaBB SE Development Team                                 */
/*****************************************************************************/
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* The GNU GPL can be found in gpl.txt in this directory                     */
/*****************************************************************************/
?>
<html>
<head>
	<title>YaBB SE Installer</title>
<style>
<!--
body {
	font-family : Verdana;
	font-size : 10pt;
}
td {
	font-size : 10pt;
}
-->
</style>
</head>
<body bgcolor="#FFFFFF">
<center><table border="0" cellspacing="1" cellpadding="4" bgcolor="#000000" width="90%">
<tr>
	<th bgcolor="#34699E"><font color="#FFFFFF">YaBB SE Installer</font></th>
</tr>
<tr>
	<td bgcolor="#f0f0f0">
<?php

if(!isset($HTTP_GET_VARS['step']))
{
	$mode = ini_get('safe_mode');
	echo '<br />Safe Mode Check:<br />';
	if ($mode)
		echo '<font color=red><br />Warning! It appears that safe mode is enabled.<br /> <br />This version of the YaBB SE Installer will not work with safe mode enabled. You should download the safe mode installer from <a href=\"http://www.yabbse.org/downloads.php\">yabbse.org</a> and procede with your installation using that version.<br /> <br />If you know for a fact that safe mode is NOT enabled, you may continue, although this is strongly discouraged.</font><br /> <br />';
	else
		echo '<br />It appears that safe mode has been disabled.  You may continue.<br /><br />';

	echo '<a href="' . $HTTP_SERVER_VARS['PHP_SELF'] . '?step=0">Click here</a> to continue.<br /><br />';
}
elseif ($HTTP_GET_VARS['step'] == 0)
{
	$installdir = getcwd();
	$installdir = str_replace('//', '/', $installdir);
	$installdir = str_replace('\\', '/', $installdir);
?>
This program will install YaBB SE on your webserver<br />
<form action="<?= $HTTP_SERVER_VARS['PHP_SELF'] ?>?step=2" method="POST">
<table border="0" cellspacing="0" cellpadding="3">
<tr>
	<td valign="top"><b>Install to directory:</b></td>
	<td><input type="text" name="installdir" id="installdir" value="<?php echo $installdir; ?>" size="65"><br />
	<font size="1">Create this directory first, then chmod it to 777!</font></td>
</tr>
<tr>
	<td valign="top"><b>Overwrite newer files:</b></td>
	<td><input type="checkbox" name="overwrite" id="overwrite" value="1"></td>
</tr>
</table>
<center>
<input type="submit" value="Start installation &gt;">
</center>
</form>
	<?php
}
elseif ($HTTP_GET_VARS['step'] == 2)
{
	if(!file_exists($_POST['installdir']))
		die("Directory {$HTTP_GET_VARS['installdir']} does not exist yet, please create it first");
	$directory = $_POST['installdir'];
	if(!file_exists("$directory/attachments"))
	{
		mkdir("$directory/attachments", 0777);
		chmod("$directory/attachments", 0777);
	}

	echo "Installation starts now...<br /><br />\n";
	$af = fopen('yse150.ya','rb');
	while(!feof($af))
	{
		$data = explode('|^|', chop(fgets($af, 4086)));
		if (!isset($data[1]))
			$data[1] = '';
		$filename = $directory . '/' . $data[1];
		if ($data[0] == 'dir' && !file_exists($filename) && $data[1] != ".")
		{
			mkdir($filename, 0777);
			chmod($filename, 0777);
		}
		if($data[0] == "file")
		{
			if (file_exists($filename) && filemtime($filename) >= $data[3] && !isset($_POST['overwrite']))
				echo "Skipping $filename because it's a newer version or a version of the same age<br />\n";
			else
			{
				$buffer = fread($af, $data[2]);
				$fp = fopen($filename, 'wb');
				fputs($fp, $buffer, $data[2]);
				fclose($fp);
				chmod($filename, 0666);
				touch($filename, $data[3]);
				//echo system("chown $filename $chownuser");
				echo "Wrote $filename ...<br />\n";
			}
		}
	}
	fclose($af);

	@chmod("$directory/yabbinfo.xml", 0777);
	@chmod("$directory/Settings_bak.php", 0777);
	@chmod("$directory/Packages/installed.list", 0777);
	@chmod("$directory/Packages/server.list", 0777);

	echo '
<form action="' . $HTTP_SERVER_VARS['PHP_SELF'] . '?step=3" method="POST">
<input type="hidden" name="installdir" id="installdir" value="' . $_POST['installdir'] . '">
<input type="submit" value="Proceed &gt;">
</form>';

}
elseif ($HTTP_GET_VARS['step'] == 3)
{
?>
You will now have to set some settings you need to set =\)
<form action="<?= $HTTP_SERVER_VARS['PHP_SELF'] ?>?step=4" method="POST">
<table border="0" cellspacing="0" cellpadding="3">
<tr>
	<td valign="top"><b>MySQL server name:</b></td>
	<td><input type="text" name="db_server" id="db_server" value="localhost"><br />
	<font size="1">This is nearly always localhost, so if you don't know use localhost</font></td>
</tr>
<tr>
	<td valign="top"><b>MySQL username:</b></td>
	<td><input type="text" name="db_user" id="db_user" value=""><br />
	<font size="1">Fill in the username you need to connect to your MySQL database, if you don't know, try the username of your ftp account, most of the times those two are equal.</font></td>
</tr>
<tr>
	<td valign="top"><b>MySQL password:</b></td>
	<td><input type="password" name="db_passwd" id="db_passwd" value=""><br />
	<font size="1">Fill in the password you need to connect to your MySQL database, if you don't know, try the password of your ftp account, most of the times they're the same.</font></td>
</tr>
	<tr>
	<td valign="top"><b>MySQL Database name:</b></td>
	<td><input type="text" name="db_name" value="yabbse"><br />
	<font size="1">Fill in the name of the database you want to use to let YaBB SE store it's data in, <b>make sure it is empty or at least doesn't contain important info, it is very likely that it will be destroyed<br />If this database does not exist, we will try to create it.</b></font></td>
</tr>
	<tr>
	<td valign="top"><b>MySQL Database prefix:</b></td>
	<td><input type="text" name="db_prefix" value="yabbse_"><br />
	<font size="1">Fill in the prefix you would like to use on all your table names.  You may leave this blank.  This value will be prepended to all table names to allow for multiple YaBB SE installations in a single database.</font></td>
</tr>
</table>
<center>
<input type="hidden" name="installdir" value="<?php echo $_POST['installdir']; ?>">
<input type=submit value="Proceed &gt;"> (Only proceed if successful!)
</center>
</form>
<?php
}
elseif ($HTTP_GET_VARS['step'] == 4)
{
	$db_name = $_POST['db_name'];
	$db_user = $_POST['db_user'];
	$db_passwd = $_POST['db_passwd'];
	$db_server = $_POST['db_server'];
	$db_prefix = $_POST['db_prefix'];
	$goon = 1;
	$settingsArray = file("{$_POST['installdir']}/Settings.php");
	for ($i = 0; $i < sizeof($settingsArray); $i++)
		$settingsArray[$i] = trim($settingsArray[$i]);

	// create a unique encryption key
	$key = md5(uniqid(microtime(), 1));

	if (!isset($_POST['db_prefix']))
		$db_prefix = '';
	else
		$db_prefix = $_POST['db_prefix'];

	$settingsArray[59] = "\$db_name = \"$db_name\";";
	$settingsArray[60] = "\$db_user = \"$db_user\";";
	$settingsArray[61] = "\$db_passwd = \"$db_passwd\";";
	$settingsArray[62] = "\$db_server = \"$db_server\";";
	$settingsArray[63] = "\$db_prefix = \"$db_prefix\";";
	$settingsArray[78] = "\$encryption_key = \"$key\";";

	$fp = fopen("{$_POST['installdir']}/Settings.php", 'w');
	foreach($settingsArray as $row)
		fputs($fp, "$row\n");
	fclose ($fp);

	$linkid = mysql_connect($db_server, $db_user, $db_passwd);
	if(!$linkid)
	{
		echo 'Cannot connect to database server with given data';
		$goon = 0;
	}
	if($goon)
	{
		mysql_query("CREATE DATABASE IF NOT EXISTS $db_name");
		if(!mysql_select_db($db_name, $linkid))
		{
			echo "Connection to server succeeded, but cannot use database $db_name.";
			$goon = 0;
		}
	}
	if($goon)
	{
		$fd = fopen("{$_POST['installdir']}/yse150.sql", 'r');

		$query = '';
		$counter = 0;
		while (!feof($fd))
		{
			$line = fgets($fd, 4096);
			$line = chop($line);

			$line = str_replace("{\$db_prefix}", $db_prefix, $line);

			if(!ereg("^#", $line))
			$query .= $line;
			if ((ereg(";\n?$", $line) || feof($fd)) && $query != '')
			{
				$counter++;
				echo "<i>Inserting data package $counter</i><br />";
				if (!mysql_query($query))
					print '<i>Errors: ' . mysql_error() . "</i><br /><br />\n";
				else
					print "<i>No Errors</i><br /><br />\n";
				$query = '';
			}
			if ($counter % 200 == 0)
				@set_time_limit(240);
		}
		fclose($fd);

		$tables = mysql_list_tables($db_name);
		while(list($bla) = mysql_fetch_array($tables))
			mysql_query("OPTIMIZE TABLE $bla");
	
		$tables = mysql_list_tables($db_name);
		while(list($bla) = mysql_fetch_array($tables))
			mysql_query("ALTER TABLE $bla type=MyISAM");
?>
      <center>
	<form action="<?= $HTTP_SERVER_VARS['PHP_SELF'] ?>?step=5" method="POST">
	<input type="hidden" name="db_user" value="<?php echo $db_user; ?>">
	<input type="hidden" name="db_passwd" value="<?php echo $db_passwd; ?>">
	<input type="hidden" name="db_prefix" value="<?php echo $db_prefix; ?>">
	<input type="hidden" name="db_name" value="<?php echo $db_name; ?>">
	<input type="hidden" name="db_server" value="<?php echo $db_server; ?>">
	<input type="hidden" name="installdir" value="<?php echo $_POST['installdir']; ?>">
	<input type="submit" value="Proceed &gt;">
	</form>
      </center>
<?php
	}
}
elseif ($HTTP_GET_VARS['step'] == 5)
{
?>
<script>
function updateFields()
{
	if (document.layers || document.all || document.getElementById) {
		pForm = document.step6form;
		pForm.imagesdir.value = pForm.boardurl.value + "/YaBBImages";
		pForm.facesurl.value = pForm.boardurl.value + "/YaBBImages/avatars";
	}
}
</script>
We now need to ask you for the forum URLs so you can use YaBB SE
<form action="<?= $HTTP_SERVER_VARS['PHP_SELF'] ?>?step=6" method="POST" name="step6form">
<table border="0" cellspacing="0" cellpadding="3">
<tr>
	<td valign="top"><b>Board URL:</b></td>
	<td><input type="text" name="boardurl" value="http://www.myserver.com/yabbse" size="65" onChange="updateFields();"><br />
	<font size="1">This is the url of your site without the trailing '/'.</font></td>
</tr>
<tr>
	<td valign="top"><b>Images URL:</b></td>
	<td><input type="text" name="imagesdir" value="http://www.myserver.com/yabbse/YaBBImages" size="65"><br />
	<font size="1">This is the location of your yabb images including the buttons, icons etc.</font></td>
</tr>
<tr>
	<td valign="top"><b>Faces URL:</b></td>
	<td><input type="text" name="facesurl" value="http://www.myserver.com/yabbse/YaBBImages/avatars" size="65"><br />
	<font size="1">This is the location of the avatars.  It is, by default, the avatars sub-directory in your images folder.</font></td>
</tr>
</table>
<center>
<input type="hidden" name="db_user" value="<?php echo $_POST['db_user']; ?>">
<input type="hidden" name="db_passwd" value="<?php echo $_POST['db_passwd']; ?>">
<input type="hidden" name="db_prefix" value="<?php echo $_POST['db_prefix']; ?>">
<input type="hidden" name="db_name" value="<?php echo $_POST['db_name']; ?>">
<input type="hidden" name="db_server" value="<?php echo $_POST['db_server']; ?>">
<input type="hidden" name="installdir" value="<?php echo $_POST['installdir']; ?>">
<input type=submit value="Proceed &gt;">
</center>
</form>
<?php
}
elseif ($HTTP_GET_VARS['step'] == 6)
{
	$settingsArray = file("{$_POST['installdir']}/Settings.php");
	for ($i = 0; $i < sizeof($settingsArray); $i++)
	$settingsArray[$i] = trim($settingsArray[$i]);

	// do the input ones
	$settingsArray[42] = "\$boardurl = \"{$_POST['boardurl']}\";				# URL of your board's folder (without trailing '/')";
	$settingsArray[71] = "\$facesurl = \"{$_POST['facesurl']}\";				# URL to your avatars folder";
	$settingsArray[72] = "\$imagesdir = \"{$_POST['imagesdir']}\";				# URL to your images directory";

	$settingsArray[68] = "\$boarddir = \"{$_POST['installdir']}\"; 				# The absolute path to the board's folder (usually can be left as '.')";

	// now generate others
	$settingsArray[69] = "\$sourcedir = \"{$_POST['installdir']}/Sources\"; 				# Directory with YaBB source files";
	$settingsArray[70] = "\$facesdir = \"{$_POST['installdir']}/YaBBImages/avatars\";				# Absolute Path to your avatars folder";
	$settingsArray[73] = "\$ubbcjspath = \"{$_POST['boardurl']}/ubbc.js\";	                        # Web path to your 'ubbc.js' REQUIRED for post/modify to work properly!";
	$settingsArray[74] = "\$faderpath = \"{$_POST['boardurl']}/fader.js\";				# Web path to your 'fader.js'";
	$settingsArray[75] = "\$helpfile = \"{$_POST['boardurl']}/YaBBHelp/index.html\";				# Location of your help file;";

	$fp = fopen("{$_POST['installdir']}/Settings.php", "w");
	foreach ($settingsArray as $row)
		fputs($fp, "$row\n");
	fclose ($fp);

?>
    <center>
	<form action="<?= $HTTP_SERVER_VARS['PHP_SELF'] ?>?step=7" method="POST">
	<br /><br />Settings.php was modified successfully<br />
	<input type="hidden" name="db_user" value="<?php echo $_POST['db_user']; ?>">
	<input type="hidden" name="db_passwd" value="<?php echo $_POST['db_passwd']; ?>">
	<input type="hidden" name="db_prefix" value="<?php echo $_POST['db_prefix']; ?>">
	<input type="hidden" name="db_name" value="<?php echo $_POST['db_name']; ?>">
	<input type="hidden" name="db_server" value="<?php echo $_POST['db_server']; ?>">
	<input type="hidden" name="installdir" value="<?php echo $_POST['installdir']; ?>">
        <input type="hidden" name="boardurl" id="boardurl" value="<?php echo $_POST['boardurl']; ?>">
	<input type="submit" value="Proceed &gt;">
	</form>
      </center>
<?php
}
elseif ($HTTP_GET_VARS['step'] == 7)
{
?>
You will now have to set up an adminstrator account
<form action="<?= $HTTP_SERVER_VARS['PHP_SELF'] ?>?step=8" method="POST">
<table border="0" cellspacing="0" cellpadding="3">
<tr>
	<td valign="top"><b>Your username:</b></td>
	<td><input type="text" name="username" value=""><br />
	<font size="1">Choose the user name you would like to have, this account will automatically get admin rights</font></td>
</tr>
<tr>
	<td valign="top"><b>Password:</b></td>
	<td><input type="password" name="password1" id="password1"><br />
	<font size="1">Fill in your prefered password here, remember it well!</font></td>
</tr>
<tr>
	<td valign="top"><b>Password again:</b></td>
	<td><input type="password" name="password2" id="password2"><br />
	<font size="1">Just for verification</font></td>
</tr>
<tr>
	<td valign="top"><b>E-Mail:</b></td>
	<td><input type="text" name="email" id="email" size="20"></td>
</tr>
<tr>
	<td valign="top"><b>Skip this:</b></td>
	<td><input type="checkbox" name="skip" id="skip"><font size="1">Only check this if you DO NOT want to set up an admin account.  Most likely this will only happen if you intend to continue and convert an existing Y1G board.</font></td>
</tr>
</table>
<center>
<input type="hidden" name="db_user" value="<?php echo $_POST['db_user']; ?>">
<input type="hidden" name="db_passwd" value="<?php echo $_POST['db_passwd']; ?>">
<input type="hidden" name="db_prefix" value="<?php echo $_POST['db_prefix']; ?>">
<input type="hidden" name="db_name" value="<?php echo $_POST['db_name']; ?>">
<input type="hidden" name="db_server" value="<?php echo $_POST['db_server']; ?>">
<input type="hidden" name="installdir" value="<?php echo $_POST['installdir']; ?>">
<input type="hidden" name="boardurl" id="boardurl" value="<?php echo $_POST['boardurl']; ?>">
<input type=submit value="Proceed &gt;">
</center>
</form>
<?php
}
elseif ($HTTP_GET_VARS['step'] == 8)
{
	include("{$_POST['installdir']}/Settings.php");
	if(!isset($_POST['skip']))
	{
		if($_POST['password1'] != $_POST['password2'])
			die('Passwords did not match');
		$linkid = mysql_connect($_POST['db_server'], $_POST['db_user'], $_POST['db_passwd']);
		mysql_select_db($_POST['db_name'], $linkid);
		$queryPasswdPart = crypt($_POST['password1'], substr($_POST['password1'], 0, 2));
		// This will have to change obviously ;)
		$result = mysql_query("
			INSERT INTO {$db_prefix}members (memberName, realName, passwd, emailAddress, memberGroup, posts, personalText, avatar, dateRegistered, hideEmail)
			VALUES ('" . addslashes($_POST['username']) . "', '" . addslashes($_POST['username']) . "', '$queryPasswdPart', '{$_POST['email']}', 'Administrator', '0', '', 'blank.gif', '" . time() . "', '0');");
		if(!$result)
		{
			echo "Error: ".mysql_error();
			exit;
		}
		echo "An administrator account has been created, you can now proceed to your newly created board.<br />
		<b>Please remember to delete install.php or rename it so it can't be executed, and to chmod your installation dir to something other than 777</b><br />";
	}
?>
	Congratulations, the installation is complete!
	  <p><blockquote><a href="<?php echo $_POST['boardurl']; ?>/index.php">Go to your board</a><br /></p>
	  <p>Good luck!<br />The YaBB SE team.</p>
<?php
}
?>
    </td>
  </tr>
</table>
</center>
</body>
</html>
